目录

Creating a Gift Card Model

Function

Adds a gift card model to the Huawei server.

Scenario

This API is used to add a gift card model to the Huawei server.

Restrictions

You need to create an app in AppGallery Connect and apply for services corresponding to the passes.

Prototype

Protocol

HTTPS POST

Direction

Developer server -> Huawei server

URL

{url}/hmspass/v1/giftcard/model

Set the {url} variable based on the region where the server is located. For details, please refer to Wallet Server Addresses.

Data Format

Request: Content-Type: application/json

Response: Content-Type: application/json

Request Parameters

Request Header

Parameter

Mandatory/Optional

Type

Description

Authorization

Mandatory

String

Authorization code. For details about how to obtain the value, please refer to the Client Credentials mode in OAuth 2.0-based Authentication. In this mode, client_id and client_secret are respectively the App ID and App key of the app that you created in AppGallery Connect. Concatenate the value of access_token to the end of Bearer, with a space in between, to generate the value of Authorization.

Content-Type

Mandatory

String

The value is always application/json;charset=utf-8.

Accept

Mandatory

String

The value is always application/json;charset=utf-8.

Request Body

Parameter

Mandatory/Optional

Type

Description

For details, please refer to the HwWalletObject Parameters.

Mandatory

HwWalletObject

Pass model to be added.

Request Example

POST /hmspass/v1/giftcard/model HTTP/1.1
Content-Type: application/json;charset=utf-8
Authorization: Bearer ***
Host: wallet-passentrust-drcn.cloud.huawei.com.cn
Accept: application/json;charset=utf-8
{
  "passVersion": "1.0",
  "passTypeIdentifier": "hwpass.com.huawei.wallet.giftcard.test",
  "passStyleIdentifier": "giftCardModelTest",
  "organizationName": "Huawei",
  "fields": {
    "countryCode": "CN",
    "locationList": [
      {
        "longitude": "114.0679603815",
        "latitude": "22.6592051284"
      }
    ],
    "commonFields": [
      {
        "key": "logo",
        "value": "https://www.huawei.com/XXX.png"
      },
      {
        "key": "backgroundImage",
        "value": "https://www.huawei.com/XXX.png"
      },
      {
        "key": "name",
        "value": "Gift Card"
      },
      {
        "key": "merchantName",
        "value": "XXX Super Market",
        "localizedValue": "merchantNameI18N"
      },
      {
        "key": "eventNumber",
        "value": "223421515222143",
        "label": "Event Number",
        "localizedValue": "eventNameI18n"
      }
    ],
    "appendFields": [
      {
        "key": "backgroundColor",
        "value": "#483d8b"
      },
      {
        "key": "hotline",
        "value": "8006011450"
      },
      {
        "key": "website",
        "value": "https://www.huawei.com"
      }
    ],
    "messageList": [
      {
        "key": "message[0]",
        "value": "Welcome to use this gift card.",
        "label": "Welcome"
      },
      {
        "key": "message[1]",
        "value": "This gift card is used for XXX.",
        "label": "Explanation"
      }
    ],
    "imageList": [
      {
        "key": "mainImage[0]",
        "value": "https://www.huawei.com/XXX0.png"
      },
      {
        "key": "mainImage[1]",
        "value": "https://www.huawei.com/XXX1.png"
      },
      {
        "key": "mainImage[2]",
        "value": "https://www.huawei.com/XXX2.png"
      }
    ],
    "localized": [
      {
        "key": "merchantNameI18N",
        "language": "zh-cn",
        "value": "XXX Super Market"
      },
      {
        "key": "merchantNameI18N",
        "language": "en",
        "value": "XXX Super Market"
      },
      {
        "key": "eventNumberI18N",
        "language": "zh-cn",
        "value": "Event Number"
      },
      {
        "key": "eventNumberI18N",
        "language": "en",
        "value": "Event Number"
      }
    ]
  }
}

Response Parameters

When the result code is 200:

Parameter

Type

Description

For details, please refer to the HwWalletObject Parameters.

HwWalletObject

Added pass model.

Response Example

HTTP/1.1 200 OK
Content-Type: application/json
{
  "passVersion": "1.0",
  "passTypeIdentifier": "hwpass.com.huawei.wallet.giftcard.test",
  "passStyleIdentifier": "giftCardModelTest",
  "organizationName": "Huawei",
  "fields": {
    "countryCode": "CN",
    "locationList": [
      {
        "longitude": "114.0679603815",
        "latitude": "22.6592051284"
      }
    ],
    "commonFields": [
      {
        "key": "logo",
        "value": "https://www.huawei.com/XXX.png"
      },
      {
        "key": "backgroundImage",
        "value": "https://www.huawei.com/XXX.png"
      },
      {
        "key": "name",
        "value": "Gift Card"
      },
      {
        "key": "merchantName",
        "value": "XXX Super Market",
        "localizedValue": "merchantNameI18N"
      },
      {
        "key": "eventNumber",
        "value": "223421515222143",
        "label": "Event Number",
        "localizedValue": "eventNameI18n"
      }
    ],
    "appendFields": [
      {
        "key": "backgroundColor",
        "value": "#483d8b"
      },
      {
        "key": "hotline",
        "value": "8006011450"
      },
      {
        "key": "website",
        "value": "https://www.huawei.com"
      }
    ],
    "messageList": [
      {
        "key": "message[0]",
        "value": "Welcome to use this gift card.",
        "label": "Welcome"
      },
      {
        "key": "message[1]",
        "value": "This gift card is used for XXX.",
        "label": "Explanation"
      }
    ],
    "imageList": [
      {
        "key": "mainImage[0]",
        "value": "https://www.huawei.com/XXX0.png"
      },
      {
        "key": "mainImage[1]",
        "value": "https://www.huawei.com/XXX1.png"
      },
      {
        "key": "mainImage[2]",
        "value": "https://www.huawei.com/XXX2.png"
      }
    ],
    "localized": [
      {
        "key": "merchantNameI18N",
        "language": "zh-cn",
        "value": "XXX Super Market"
      },
      {
        "key": "merchantNameI18N",
        "language": "en",
        "value": "XXX Super Market"
      },
      {
        "key": "eventNumberI18N",
        "language": "zh-cn",
        "value": "Event Number"
      },
      {
        "key": "eventNumberI18N",
        "language": "en",
        "value": "Event Number"
      }
    ]
  }
}

Result Codes

For details, please refer to Result Codes.

Call Example

public HwWalletObject postHwWalletObjectToWalletServer(String url, HwWalletObject hwWalletObject) {
    // Construct the HTTP header.
    HttpHeaders header = constructHttpHeaders();
    // Construct the HTTP body.
    String body = CommonUtil.toJson(hwWalletObject);
    JSONObject jsonObj = JSONObject.parseObject(body);
    System.out.println("Request JSON : " + jsonObj);
    // Construct the HTTP URL.
    String baseUrl = ConfigHelper.instants().getValue("walletServerBaseUrl");
    String walletServerUrl = baseUrl + url;

    // Send the HTTP request and obtain the response.
    HttpEntity<JSONObject> entity = new HttpEntity<>(jsonObj, header);
    ResponseEntity<HwWalletObject> exchange =
        REST_TEMPLATE.exchange(walletServerUrl, HttpMethod.POST, entity, HwWalletObject.class);

    // Return the pushed wallet model.
    return exchange.getBody();
}